import java.io.*;
import java.util.*;
import javax.swing.Timer;
import java.awt.event.*;

public class servers
{
	public static int MAX_CLINES = 50;
	public static int MAX_SERVERS = 100;
	public static int MAX_LAGREPLYCHANS = 3;
	public static int MAX_HUBS = 30;
	
	public static String[][] current = new String[MAX_SERVERS][2];
	//public static String[][] currentinorder = new String[MAX_SERVERS][2];
	public static String[][] serverlist = new String[MAX_SERVERS][1];
	public static String[][] splitlist = new String[MAX_SERVERS][3];
	
	public static String[][] clines = new String[MAX_SERVERS][MAX_CLINES];
	
	public static boolean map = false;
	
	public static String[][] hublag = new String[100][2];
	public static String[][] lagreplychan = new String[MAX_LAGREPLYCHANS][MAX_HUBS];
	public static int ldelay = 30000; // 30 seconds for lag reply check
	public static Timer cr;
	
	
	public static String[][] su = new String[100][1];
	
	
	public static String [][] sortNum(String[][] table) 
    {
        String [][] newtable = new String[100][2];
        for (int a = 0;a < table.length; a++) //-> this one is for the server
        {
            if (table[a][1] == null) continue;
            String server = table[a][0];
            int users = Integer.parseInt(table[a][1]);
            int location=0;
            while (server == null) 
            {
                for (int c = 0;c < table.length; c++)
                {
                    if (table[c][1] == null) continue;
                    server = table[c][0]; //we get server name.
                    if (server != null) break;
                    users = Integer.parseInt(table[a][1]); //-> we get user count for server to start us off.
                }
            }
            for (int b = 0;b < table.length; b++) //-> this one for the users #s
            {
                if (table[b][1] == null) continue;
                if (table[b][0] == null) continue;
                //-> here is where we do the user # comparison, 
                //-> to see which is largest
                
                String newserver = table[b][0];
                int newusers = Integer.parseInt(table[b][1]);
                if (users < newusers )
                {
                    //-> if old 'users' is less than 'newusers',
                    //-> we set the new one in the variable.
                    server = newserver;
                    users = newusers;
                    location = b;
                }
                else if(users == newusers) continue;
            } 
            table[location][0] = null;
            table[location][1] = "-1";
            newtable[a][0] = server;
            newtable[a][1] = String.valueOf(users);

        }
        return newtable;
    }
	
	
	public static void addlagreplychan(String target)
	{
		for (int i=0;i<MAX_LAGREPLYCHANS;i++)
		{
			if (lagreplychan[i][0] != null && lagreplychan[i][0].equalsIgnoreCase(target)) { break; }
			else if (lagreplychan[i][0] == null) { lagreplychan[i][0] = target; break; }
		}
	}
	public static void addlagreplyserver(String target, String server)
	{
		//System.out.println("adding "+server);
		for (int i=0;i<MAX_LAGREPLYCHANS;i++)
		{
			if (lagreplychan[i][0] != null && lagreplychan[i][0].equalsIgnoreCase(target)) {
				for (int x=1;x<MAX_HUBS;x++)
				{
					if (lagreplychan[i][x] != null && lagreplychan[i][x].equalsIgnoreCase(server)) { break; }
					else if (lagreplychan[i][x] == null) { lagreplychan[i][x] = server; break; }
				}
				break;
			}
		}
	}
	public static void dellagreplyserver(String server)
	{
		//System.out.println("removing "+server);
		for (int i=0;i<MAX_LAGREPLYCHANS;i++)
		{
			if (lagreplychan[i][0] != null) {
				for (int x=1;x<MAX_HUBS;x++)
				{
					if (lagreplychan[i][x] != null && lagreplychan[i][x].equalsIgnoreCase(server)) {
						lagreplychan[i][x] = null; break;
					}
				}
				// ********************************
				//break;
			}
		}
	}
	
	public static void addhub(String hub)
	{
		for (int ln=1;ln<hublag.length;ln++)
		{
			if (hublag[ln][1] == null) {
				hublag[ln][1] = hub;
				break;
			}
		}
	}
	public static void delhub(String hub)
	{
		for (int ln=1;ln<hublag.length;ln++)
		{
			if (hublag[ln][1] != null && hublag[ln][1].equalsIgnoreCase(hub)) {
				hublag[ln][1] = null;
				break;
			}
		}
	}
	public static void checkhub(String target)
	{
		final String targ = target;
  		cr = new Timer(ldelay, new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			
    			for (int sq=1; sq<hublag.length; sq++)
    			{
    				if (hublag[sq][1] == null) {
    					continue;
    				}
    				else {
    					
    					for (int ii=0;ii<MAX_LAGREPLYCHANS;ii++)
                		{
                			if (lagreplychan[ii][0] != null) {
                				for (int xx=1;xx<MAX_HUBS;xx++)
                				{
                					if (lagreplychan[ii][xx] != null && lagreplychan[ii][xx].equalsIgnoreCase(hublag[sq][1])) {
                						jbot.jmsg(lagreplychan[ii][0], "[Hublag] No reply from " +hublag[sq][1]+ " in 30 seconds.");
                						
                					}
                				}
                			}
                		}
                		//dellagreplyserver(lse[0]);
    					
    					
    					
    					
    					//jbot.jmsg(targ, "[Hublag] No reply from " +hublag[sq][1]+ " in 30 seconds.");
    					hublag[sq][1] = null;
    				}
    			}
    			cr.stop();
      		}
  		});
  		cr.start();
	}
	
	public static void listmap(String target, int min)
	{
		int n=0;
		int nusers=0;
		int totserv =0;
		int totusers=0;
		jbot.jmsg(target, "[map] Listing servers holding a minimum of "+min+" users.");
		for (int i=0; i<current.length;i++)
		{
			if (current[i][0] != null && Integer.parseInt(current[i][1]) >= min) {
				jbot.jmsg(target, "[map] "+current[i][0]+" | "+current[i][1]);
				n=n+1; totserv = totserv+1;
				nusers = nusers+Integer.parseInt(current[i][1]);
				totusers = totusers+Integer.parseInt(current[i][1]);
			}
			else if (current[i][0] != null) {
				totserv = totserv+1;
				totusers = totusers+Integer.parseInt(current[i][1]);
			}
		}
		double nu = ((double) nusers / totusers) *100;
		String percent = jbot.shortdecimal(Double.toString(nu));
		jbot.jmsg(target, "[map] servers["+n+"/"+totserv+"] users["+nusers+"/"+totusers+"] percent["+percent+"%]");
	}
	
	public static void listmap(String target, String match)
	{
		int n=0;
		int nusers=0;
		int totserv =0;
		int totusers=0;
		jbot.jmsg(target, "[map] Listing servers that match *"+match+"*.");
		for (int i=0; i<current.length;i++)
		{
			if (current[i][0] != null && jbot.iswm("*"+match+"*",current[i][0])) {
				jbot.jmsg(target, "[map] "+current[i][0]+" | "+current[i][1]);
				n=n+1; totserv = totserv+1;
				nusers = nusers+Integer.parseInt(current[i][1]);
				totusers = totusers+Integer.parseInt(current[i][1]);
			}
			else if (current[i][0] != null) {
				totserv = totserv+1;
				totusers = totusers+Integer.parseInt(current[i][1]);
			}
		}
		//double nu = (double) nusers / totusers; nu = nu*100;
		double nu = ((double) nusers / totusers) *100;
		String percent = jbot.shortdecimal(Double.toString(nu));
		jbot.jmsg(target, "[map] servers["+n+"/"+totserv+"] users["+nusers+"/"+totusers+"] percent["+percent+"%]");
	}
	
	public static void reordercurrent()
	{
		int[] usr = new int[MAX_SERVERS];
		String[][] rc = new String[MAX_SERVERS][2];
		for (int i=0;i<current.length;i++)
		{
			if (current[i][1] == null) { continue; }
			if (!jbot.isnum(current[i][1],false)) { continue; }
			usr[i] = Integer.parseInt(current[i][1]);
		}
		Arrays.sort(usr);
		int as = -1;
		for (int i=usr.length-1;i > -1;i--)
		{
			for (int x=0; x<current.length;x++)
			{
				if (current[x][1] != null && current[x][1].equals(Integer.toString(usr[i]))) {
					as = as+1;
					rc[as][0] = current[x][0]; current[x][0] = null;
					rc[as][1] = Integer.toString(usr[i]); current[x][1] = null;
					break;
				}
			}
		}
		for (int i=0; i<rc.length; i++)
		{
			if (rc[i][0] == null) { continue; }
			else { current[i][0] = rc[i][0]; current[i][1] = rc[i][1]; }
		}
	}
	
	public static void statsc(String hub, String server, String port)
	{
		for (int i=0;i<clines.length;i++)
		{
			if (clines[i][0] == null) {
				clines[i][0] = hub;
				clines[i][1] = port+" "+server;
				break;
			}
			else if (clines[i][0].equalsIgnoreCase(hub)) {
				for (int b=1;b<MAX_CLINES;b++)
				{
					if (clines[i][b] == null) {
						clines[i][b] = port+" "+server;
						break;
					}
					else if (clines[i][b].split("[ \\s]+")[1].equalsIgnoreCase(server)) { break; }
				}
				break;
			}
		}
	}
	
	public static void matchcline(String target)
	{
		for (int i=0;i<clines.length;i++)
		{
			if (clines[i][0] != null) {
				for (int x=1;x<MAX_CLINES;x++)
				{
					if (clines[i][x] != null) {
						for (int ii=0;ii<clines.length;ii++)
						{
							if (clines[ii][0] != null && clines[ii][0].equalsIgnoreCase(clines[i][x].split("[ \\s]+")[1])) {
								for (int xx=1;xx<MAX_CLINES;xx++)
								{
									if (clines[ii][xx] != null && clines[ii][xx].split("[ \\s]+")[1].equalsIgnoreCase(clines[i][0])) { break; }
									else if (xx+1 == MAX_CLINES) {
										for (int z=0;z<serverlist.length;z++)
										{
											if (serverlist[z][0] != null && serverlist[z][0].equalsIgnoreCase(clines[i][x].split("[ \\s]+")[1])) {
												jbot.jmsg(target, "[c-line] Broken link: "+clines[i][0]+" -> "+clines[i][x].split("[ \\s]+")[1]+" | No match found on "+clines[i][x].split("[ \\s]+")[1]);
												break;
											}
											else if (z+1 == serverlist.length) {
												System.out.println("CLINE: Server "+clines[i][x].split("[ \\s]+")[1]+" no longer exists");
											}
										}
										
									}
								}
								break;
							}
						}
					}
				}
			}
		}
	}
	
	public static void listclines(String target, String server)
	{
		int t = 0;
		for (int i=0; i<clines.length;i++)
		{
			if (clines[i][0] == null) { continue; }
			else if (jbot.iswm("*"+server+"*", clines[i][0])) {
				for (int z=1;z<MAX_CLINES;z++)
				{
					if (clines[i][z] == null) { break; }
					else if (clines[i][z] != null) {
						for (int y=0;y<clines.length;y++)
						{
							if (clines[y][0] != null && clines[y][0].equalsIgnoreCase(clines[i][z].split("[ \\s]+")[1])) {
								for (int p=1;p<MAX_CLINES;p++)
								{
									if (clines[y][p] != null && clines[y][p].split("[ \\s]+")[1].equalsIgnoreCase(clines[i][0])) {
										for (int q=0;q<serverlist.length;q++)
										{
											if (serverlist[q][0] != null && serverlist[q][0].equalsIgnoreCase(clines[i][z].split("[ \\s]+")[1])) {
												jbot.jmsg(target, "[c-line] /connect "+clines[i][0]+" "+clines[i][z]);
												t = t+1; break;
											}
											else if (q+1 == serverlist.length) {
												System.out.println("CLINE: Server "+clines[i][z].split("[ \\s]+")[1]+" no longer exists");
											}
										}
										break;
									}
									else if (p+1 == MAX_CLINES) {
										jbot.jmsg(target, "[c-line] Broken link: "+clines[i][0]+" -> "+clines[i][z].split("[ \\s]+")[1]+" | No match found on "+clines[i][z].split("[ \\s]+")[1]);
										break;
									}
								}
								break;
							}
						}
					}
				}
				break;
			}
		}
		if (t == 0) { jbot.jmsg(target, "[c-line] no results found for *"+server+"*."); }
		else if (t == 1) { jbot.jmsg(target, "[c-line] "+t+" matching result found"); }
		else { jbot.jmsg(target, "[c-line] "+t+" matching results found"); }
	}
	
	public static void loadservers() //run on start only or needs to flush arrays
	{
		try
        {
            FileReader inx = new FileReader ("servers");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            int x = 0;
            while ((str = inn.readLine()) != null) {
            	serverlist[x][0] = str;
        	    x = x+1;
            }
            inx.close();
            System.out.println("loaded server list: "+x+" servers.");
            FileReader ina = new FileReader ("splitservers");
            LineNumberReader inb = new LineNumberReader (ina);
            String sstr;
            x = 0;
            while ((sstr = inb.readLine()) != null) {
            	String[] ss = sstr.split("[ \\s]+");
            	splitlist[x][0] = ss[0];
            	splitlist[x][1] = ss[1];
            	splitlist[x][2] = ss[2];
        	    x = x+1;
            }
            inx.close();
            System.out.println("loaded split server list: "+x+" split servers.");
            
            FileReader inz = new FileReader ("clines");
            LineNumberReader inm = new LineNumberReader (inz);
            String sstrr;
            x = 0;
            while ((sstrr = inm.readLine()) != null) {
            	String[] ss = sstrr.split("[ \\s]+");
            	
            	for (int i=0;i<clines.length;i++)
            	{
            		if (clines[i][0] == null) {
            			clines[i][0] = ss[0]; clines[i][1] = ss[1]+" "+ss[2]; x = x+1;
            			break;
            		}
            		else if (clines[i][0].equalsIgnoreCase(ss[0])) {
            			for (int xk=1;xk<MAX_CLINES;xk++)
            			{
            				if (clines[i][xk] == null) {
            					clines[i][xk] = ss[1]+" "+ss[2]; x = x+1;
            					break;
            				}
            			}
            			break;
            		}
            	}
            }
            inx.close();
            System.out.println("loaded cline list: "+x+" clines.");
            
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	
	public static void buservers()
	{
		try
		{
       		BufferedWriter aout = new BufferedWriter(new FileWriter("servers"));
        	for (int i = 0;i <serverlist.length;i++) 
        	{
        		if (serverlist[i][0] == null) { continue; }
        		else { aout.write(serverlist[i][0]+"\n"); }
        	}
        	aout.close();
        	BufferedWriter bout = new BufferedWriter(new FileWriter("splitservers"));
        	for (int i = 0;i <splitlist.length;i++) 
        	{
        		if (splitlist[i][0] == null) { continue; }
        		else { bout.write(splitlist[i][0]+" "+splitlist[i][1]+" "+splitlist[i][2]+"\n"); }
        	}
        	bout.close();
        	
        	BufferedWriter cout = new BufferedWriter(new FileWriter("clines"));
        	for (int i = 0;i <clines.length;i++) 
        	{
        		if (clines[i][0] == null) { continue; }
        		else {
        			for (int z=1;z<MAX_CLINES;z++)
        			{
        				if (clines[i][z] == null) { break; }
        				else {
        					cout.write(clines[i][0]+" "+clines[i][z]+"\n");
        				}
        			}
        			
        		}
        	}
        	cout.close();
        	
        }
        catch (IOException e) {
			System.out.println("IOException in write: " + e);
	    }
	}
/*
	public static void checknew(String server)
	{
		for (int i=0;i<serverlist.length;i++)
		{
			if (serverlist[i][0] == null) { serverlist[i][0] = server; break; }
			else if (serverlist[i][0] != null && serverlist[i][0].equalsIgnoreCase(server)) { break; }
		}
	}
*/	
	public static void checknew(String server)
	{
		for (int i=0;i<serverlist.length;i++)
		{
			//if (serverlist[i][0] == null) { serverlist[i][0] = server; break; }
			if (serverlist[i][0] != null && serverlist[i][0].equalsIgnoreCase(server)) { break; }
			else if (i+1 == serverlist.length) {
				for (int m=0;m<serverlist.length;m++)
				{
					if (serverlist[m][0] == null) { serverlist[m][0] = server; break; }
				}
				break;
			}
		}
	}
	public static void updatecurrent(String server, String users)
	{
		if (!map) {
			for (int i=0;i<current.length;i++)
			{
				//if (current[i][0] == null) { current[i][0] = server; current[i][1] = users; }
				if (current[i][0] == null) { continue; }
				else { current[i][0] = null; current[i][1] = null; }
			}
			map = true;
			current[0][0] = server; current[0][1] = users;
		}
		else {
			for (int i=0;i<current.length;i++)
			{
				if (current[i][0] == null) { current[i][0] = server; current[i][1] = users; break; }
				else { continue; }
			}
		}
	}
	
	public static void listsplit(String target)
	{
		int x = 0;
		int tot = 0;
		for (int i=0;i<serverlist.length;i++)
		{
			if (serverlist[i][0] == null) { continue; }
			else {
				tot = tot+1;
				for (int a=0;a<current.length;a++)
				{
					if (current[a][0] != null && current[a][0].equalsIgnoreCase(serverlist[i][0])) {
						delsplit(serverlist[i][0]);
						break;
					}
					else if (a+1 == current.length) {
						for (int p=0;p<splitlist.length;p++)
						{
							if (splitlist[p][0] != null && splitlist[p][0].equalsIgnoreCase(serverlist[i][0])) {
								if (splitlist[p][2] != null && splitlist[p][2].equalsIgnoreCase("unknown")) {
									jbot.jmsg(target, "[Split] "+serverlist[i][0]+" <-> "+splitlist[p][1]+" <-> unknown");
									break;
								}
								else {
									jbot.jmsg(target, "[Split] "+serverlist[i][0]+" <-> "+splitlist[p][1]+" <-> "+
											jbot.formatTime((jbot.getTS()-Integer.parseInt(splitlist[p][2])))+" ago.");
									break;
								}
							}
							else if (p+1 == splitlist.length) {
								addsplit(serverlist[i][0], "unknown", "unknown");
								buservers();
								jbot.jmsg(target, "[Split] "+serverlist[i][0]+" <-> unknown <-> unknown");
								break;
							}
						}
						x = x+1; break;
					}
				}
			}
		}
		jbot.jmsg(target, "[Split] ["+x+"/"+tot+"]");
	}
	
	public static void addsplit(String server, String splitfrom, String TS)
	{
		for (int ln=0;ln<splitlist.length;ln++)
		{
			if (splitlist[ln][0] == null) {
				splitlist[ln][0] = server; splitlist[ln][1] = splitfrom;
				splitlist[ln][2] = TS;
				break;
			}
			else if (splitlist[ln][0] != null && splitlist[ln][0].equalsIgnoreCase(server)) {
				splitlist[ln][1] = splitfrom;
				splitlist[ln][2] = TS;
				break;
			}
		}
	}
	public static void delsplit(String server)
	{
		for (int ln=0;ln<splitlist.length;ln++)
		{
			if (splitlist[ln][0] != null && splitlist[ln][0].equalsIgnoreCase(server)) {
				splitlist[ln][0] = null; splitlist[ln][1] = null;
				jbot.splitexist = true;
				break;
			}
		}
	}
	public static void delserver(String server)
	{
		for (int i=0; i<serverlist.length;i++)
		{
			if (serverlist[i][0] != null && serverlist[i][0].equalsIgnoreCase(server)) {
				serverlist[i][0] = null; break;
			}
		}
	}
	
	public static void map(String server, String users)
	{
		if (jbot.getcline) {
			if (server.equalsIgnoreCase("a.c.i.d.i.c.t.i.v.e")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("geo.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("acid.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("geotest.rizon.net")) {
				//continue;
			}
			else {
				jbot.clinen = jbot.clinen+1;
				jbot.out.println("stats c "+server);
			}
		}
		else if (jbot.mapssl) {
			if (server.equalsIgnoreCase("geo.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("acid.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("services.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("geotest.rizon.net")) {
				//continue;
			}
			else {
				jbot.ssln = jbot.ssln+1;
				jbot.out.println("stats P "+server);
			}
		}
		else if (jbot.getu) {
			if (server.equalsIgnoreCase("geo.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("acid.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("services.rizon.net")) {
				//continue;
			}
			else if (server.equalsIgnoreCase("geotest.rizon.net")) {
				//continue;
			}
			else {
				addsu(server);
				jbot.getun = jbot.getun + 1;
				jbot.out.println("stats U "+server);
			}
		}
		else {
			delsplit(server);
			checknew(server);
			updatecurrent(server, users);
			
			
		}
	}
	
	public static void map(String server, String users, String target)
	{
		if (jbot.iswm("*hub*",server) || jbot.iswm("*.matrix.*",server)) {
			addhub(server); addlagreplyserver(target, server);
			jbot.out.println("stats ? "+server);
			//System.out.println("STATS ? "+server);
		}
	}
	
	
	public static void checku()
	{
		for (int i=0;i<su.length;i++)
		{
			if (su[i][0] != null) { //  && !jbot.iswm("*hub*",su[i][0])
				
				jbot.jmsg("#o", su[i][0]);
			}
		}
		jbot.getu = false;
	}
	public static void clearsu()
	{
		for (int i=0;i<su.length;i++)
		{
			if (su[i][0] != null) { su[i][0] = null; }
		}
	}
	public static void addsu(String server)
	{
		for (int i=0;i<su.length;i++)
		{
			if (su[i][0] == null) {
				su[i][0] = server;
				System.out.println("ADDED "+server+" : "+su[i][0]);
				break;
			}
		}
	}
	public static void delsu(String server)
	{
		for (int i=0;i<su.length;i++)
		{
			if (su[i][0] != null && su[i][0].equalsIgnoreCase(server)) {
				su[i][0] = null;
				System.out.println("DELETED "+server+" : "+su[i][0]);
				break;
			}
		}
	}

}