import java.io.*;
import java.util.*;
//import java.util.regex.*;
import javax.swing.Timer;
import java.awt.event.*;


public class vhost
{
	public static String[][] blnick = new String[1000][5];
	public static String[][] blvhost = new String[1000][5];
	public static String[][] blsuspicious = new String[1000][5];
	//public static String[][] vhlist = new String[50][3];
	public static String[][] opers = new String[100][2];
	public static String[][] pending = new String[99][3];
	public static String[][] approved = new String[200][2];
	public static String[][] rejected = new String[200][2];
	public static String[][] record = new String[100][6];
	private static int wait = 2*1000;
	private static Timer unsetnew;
	public static boolean firsttime = true;
	
	public static void listbynick(String nick)
	{
		savevhosts();
    	backuprecord();
    	int tot = 0; 
    	try
        {
            FileReader inx = new FileReader ("vhostlist");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
                String[] sx = str.split("\\s");
                if (sx.length>1 && sx[1].equalsIgnoreCase(nick)) {
                	tot++;
                	long time = Integer.parseInt(sx[3]);
                	long diff = Integer.parseInt(sx[4])-time;
    				String realdate = new Date(time*1000).toString();
					String what = sx[5];
					for (int r=6;r<sx.length;r++)
					{
						what += " "+sx[r];
					}
					if (diff>-1) {
                		jbot.jmsg(config.vhchan, realdate+", "+nick+" Requested: "+sx[2]+", Waited: "+jbot.formatTime(Integer.parseInt(String.valueOf(diff)))+" for "+sx[0]+", "+what+".");
                	}
                	else {
                		jbot.jmsg(config.vhchan, nick+" Requested: "+sx[2]+", Waited: NA, for "+sx[0]+", "+what+".");
                	}
                }
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
        
	}
	
	public static void record(String oper, String nick, String vhost, String what)
	{
		for (int i=0;i<record.length;i++)
		{
			if (record[i][0] == null) { record[i][0] = oper; record[i][1] = what; record[i][2] = nick; record[i][3] = vhost; record[i][4] = getrtime(nick); record[i][5] = ""+jbot.getTS(); break; } 
		}
	}
	public static String getvhost(String nick)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
				return pending[i][1];
			}
		}
		return "not found";
	}
	public static String getrtime(String nick)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
				return pending[i][2];
			}
		}
		return "0";
	}
	public static String getnick(int n)
	{
		n--;
		if (pending[n][0] != null) {
			return pending[n][0];
		}
		return "1";
	}
	public static String getnum(String nick)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
				return ""+Integer.toString(i+1);
			}
		}
		return "error";
	}
	public static void backuprecord()
	{
		try
		{
        	BufferedWriter aout = new BufferedWriter(new FileWriter(config.vhostlistdir+"vhostlist",true));
        	for (int i = 0;i<record.length;i++) 
        	{
            	if (record[i][0] != null) 
            	{
            		//[i][0]=oper [i][1]=approved/rejected [i][2]=request nick [i][3]=vhost
            		aout.write(record[i][0]+" "+record[i][2]+" "+record[i][3]+" "+record[i][4]+" "+record[i][5]+" "+record[i][1]+"\n");
            		record[i][0] = null; record[i][1] = null; record[i][2] = null; record[i][3] = null; record[i][4] = null; record[i][5] = null;
            	}
        	}
        	aout.close();
        	
        	return;
        
		} catch (IOException e) {
			System.out.println("IOException in write: " + e);
	    }
	}
	
	public static void liststats(String target)
	{
		int nicks = 0; int app = 0; int rej = 0;
		for (int i=0;i<approved.length;i++)
		{
			if (approved[i][0] != null) {
				nicks++; app = app+Integer.parseInt(approved[i][1]); rej = rej+Integer.parseInt(rejected[i][1]);
				if ((Integer.parseInt(approved[i][1])+Integer.parseInt(rejected[i][1]))>=20)
					jbot.jnotice(target, approved[i][0]+" Approved: "+approved[i][1]+", Rejected: "+rejected[i][1]);
			}
		}
		jbot.jnotice(target, "[Total] Approved: "+app+", Rejected: "+rej);
	}
	public static void liststats(String target, String nick)
	{
		int nicks = 0; int app = 0; int rej = 0;
		for (int i=0;i<approved.length;i++)
		{
			if (approved[i][0] != null && approved[i][0].startsWith(nick)) {
				nicks++; app = app+Integer.parseInt(approved[i][1]); rej = rej+Integer.parseInt(rejected[i][1]);
				//jbot.jmsg(config.vhchan, approved[i][0]+" Approved: "+approved[i][1]+", Rejected: "+rejected[i][1]);
				jbot.jnotice(target, approved[i][0]+" Approved: "+approved[i][1]+", Rejected: "+rejected[i][1]);
			}
		}
		if (nicks == 0) { jbot.jnotice(target, "No matches found for: "+nick); }
		else { jbot.jnotice(target, "[Total] Approved: "+app+", Rejected: "+rej); }
	}
	
	public static void addapproved(String nick)
	{
		for (int i=0;i<approved.length;i++)
		{
			if (approved[i][0] != null && approved[i][0].equalsIgnoreCase(nick)) {
				int count = Integer.parseInt(approved[i][1]) +1;
				approved[i][1] = Integer.toString(count);
				break;
			}
			else if (approved[i][0] == null) {
				approved[i][0] = nick; approved[i][1] = "1";
				rejected[i][0] = nick; rejected[i][1] = "0";
				break;
			}
		}
	}
	public static void addrejected(String nick)
	{
		for (int i=0;i<approved.length;i++)
		{
			if (rejected[i][0] != null && rejected[i][0].equalsIgnoreCase(nick)) {
				int count = Integer.parseInt(rejected[i][1]) +1;
				rejected[i][1] = Integer.toString(count);
				break;
			}
			else if (rejected[i][0] == null) {
				approved[i][0] = nick; approved[i][1] = "0";
				rejected[i][0] = nick; rejected[i][1] = "1";
				break;
			}
		}
	}
	
	//**************************
/*	public synchronized static void addpending(String nick, String vhost)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] == null || pending[i][1] == null || pending[i][2] == null) { pending[i][0] = nick; pending[i][1] = vhost; pending[i][2] = ""+jbot.getTS(); break; }
		}
		
	}
	public static void delpending(String nick)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
				pending[i][0] = null; pending[i][1] = null; pending[i][2] = null;
				break;
			}
		}
	}
*/	//****************************
	
	
	public synchronized static void adddelpending(String nick, String vhost)
	{
		if (vhost != null) {
			for (int i=0;i<pending.length;i++)
			{
				if (pending[i][0] == null || pending[i][1] == null || pending[i][2] == null) { pending[i][0] = nick; pending[i][1] = vhost; pending[i][2] = ""+jbot.getTS(); break; }
			}
		}
		else {
			for (int i=0;i<pending.length;i++)
			{
				if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
					pending[i][0] = null; pending[i][1] = null; pending[i][2] = null;
					break;
				}
			}
		}
		
	}

	public static boolean ispending(String nick)
	{
		for (int i=0;i<pending.length;i++)
		{
			if (pending[i][0] != null && pending[i][0].equalsIgnoreCase(nick)) {
				return true;
			}
		}
		return false;
	}
	
	public static void startup()
	{
		fillblnick();
		fillblvhost();
		fillblsuspicious();
		fillapproved();
		fillrejected();
		starthostmsg();
		System.out.println("Loaded vHost lists.");
	}
	
	public static void starthostmsg()
	{
		int delay = 600*1000; //milliseconds 10 mins
  		ActionListener msghs = new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			//savebl();
    			savevhosts();
    			backuprecord();
    			if (firsttime) { jbot.jmsg("hostserv", "waiting"); firsttime = false; }
      		}
  		};
        new Timer(delay, msghs).start();
	}
	
	public static void fillapproved()
	{
		try
        {
            FileReader inx = new FileReader ("vhapproved");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
                String[] sx = str.split("\\s");
                for (int ii = 0; ii<blnick.length;ii++) 
        		{
            		if (approved[ii][0] == null) {
                		approved[ii][0] = sx[0]; approved[ii][1] = sx[1]; break;
            		}
        		}
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	public static void fillrejected()
	{
		try
        {
            FileReader inx = new FileReader ("vhrejected");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
                String[] sx = str.split("\\s");
                for (int ii = 0; ii<blnick.length;ii++) 
        		{
            		if (rejected[ii][0] == null) {
                		rejected[ii][0] = sx[0]; rejected[ii][1] = sx[1]; break;
            		}
        		}
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	
	public static void savevhosts()
	{
		try
		{
        	BufferedWriter aout = new BufferedWriter(new FileWriter("vhapproved"));
        	for (int i = 0;i<approved.length;i++) 
        	{
            	if (approved[i][0] != null) 
            	{
            		aout.write(approved[i][0]+ " " +approved[i][1]+ "\n");
            	}
            	//else { aout.close(); break; }
        	}
        	aout.close();
        	BufferedWriter bout = new BufferedWriter(new FileWriter("vhrejected"));
        	for (int i = 0;i<rejected.length;i++) 
        	{
            	if (rejected[i][0] != null) 
            	{
            		bout.write(rejected[i][0]+ " " +rejected[i][1]+ "\n");
            	}
            	//else { bout.close(); break; }
        	}
        	bout.close();
        	return;
        
		} catch (IOException e) {
			System.out.println("IOException in write: " + e);
	    }
	}
	
	
	public static void fillblnick()
	{
		try
        {
            FileReader inx = new FileReader ("blnick");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
                String[] sx = str.split("\\s");
                String vdate = sx[2];
                for (int iw = 3; iw<8;iw++) {
                	vdate += " "; vdate += sx[iw];
                }
                String vreason = "";
          		for (int iv=8; iv<sx.length; iv++)
	        	{
	        		if (iv>8) { vreason += " "; }
	          		vreason += sx[iv];
				}
                
                for (int ii = 1; ii<blnick.length;ii++) 
        		{
        			// format 0=null 1=nick 2=who added to bl 3=date/time 4=reason
            		if (blnick[ii][1] == null) {
                		blnick[ii][1] = sx[0]; blnick[ii][2] = sx[1]; blnick[ii][3] = vdate; blnick[ii][4] = vreason; break;
            		}
        		}
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	public static void fillblvhost()
	{
		try
        {
            FileReader inx = new FileReader ("blvhost");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
            	String[] sx = str.split("\\s");
                String vdate = sx[2];
                for (int iw = 3; iw<8;iw++) {
                	vdate += " "; vdate += sx[iw];
                }
                String vreason = "";
          		for (int iv=8; iv<sx.length; iv++)
	        	{
	          		if (iv>8) { vreason += " "; }
	          		vreason += sx[iv];
				}
                
                for(int ii = 1; ii<blnick.length;ii++) 
        		{
        			// format 0=null 1=vhost 2=who added to bl 3=date/time 4=reason
            		if (blvhost[ii][1] == null) {
                		blvhost[ii][1] = sx[0]; blvhost[ii][2] = sx[1]; blvhost[ii][3] = vdate; blvhost[ii][4] = vreason; break;
            		}
        		}
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	public static void fillblsuspicious()
	{
		try
        {
            FileReader inx = new FileReader ("blsuspicious");
            LineNumberReader inn = new LineNumberReader (inx);
            String str;
            while ((str = inn.readLine()) != null) {
                String[] sx = str.split("\\s");
                String vdate = sx[2];
                for (int iw = 3; iw<8;iw++) {
                	vdate += " "; vdate += sx[iw];
                }
                String vreason = "";
          		for (int iv=8; iv<sx.length; iv++)
	        	{
	          		if (iv>8) { vreason += " "; }
	          		vreason += sx[iv];
				}
                
                for(int ii = 1; ii<blsuspicious.length;ii++) 
        		{
        			// format 0=null 1=vhost 2=who added to bl 3=date/time 4=reason
            		if (blsuspicious[ii][1] == null) {
                		blsuspicious[ii][1] = sx[0]; blsuspicious[ii][2] = sx[1]; blsuspicious[ii][3] = vdate; blsuspicious[ii][4] = vreason; break;
            		}
        		}
            }
            inx.close();
        }
        catch(IOException e)
        {
            System.out.println("IOException: " + e);
        }
	}
	
	public static void savebl()
	{
		try
		{
        	BufferedWriter aout = new BufferedWriter(new FileWriter("blnick"));
        	for (int i = 1;i <blnick.length;i++) 
        	{
            	if (blnick[i][1] != null) 
            	{
            		if (blnick[i][1].equals("-")) { continue; }
            		else { aout.write(blnick[i][1]+ " " +blnick[i][2]+ " " +blnick[i][3]+ " " +blnick[i][4]+ "\n"); }
            	}
            	else { aout.close(); break; }
        	}
        	BufferedWriter bout = new BufferedWriter(new FileWriter("blvhost"));
        	for (int i = 1;i <blvhost.length;i++) 
        	{
            	if (blvhost[i][1] != null) 
            	{
            		if (blvhost[i][1].equals("-")) { continue; }
            		else { bout.write(blvhost[i][1]+ " " +blvhost[i][2]+ " " +blvhost[i][3]+ " " +blvhost[i][4]+ "\n"); }
            	}
            	else { bout.close(); break; }
        	}
        	BufferedWriter cout = new BufferedWriter(new FileWriter("blsuspicious"));
        	for (int i = 1;i <blsuspicious.length;i++) 
        	{
            	if (blsuspicious[i][1] != null) 
            	{
            		if (blsuspicious[i][1].equals("-")) { continue; }
            		else { cout.write(blsuspicious[i][1]+ " " +blsuspicious[i][2]+ " " +blsuspicious[i][3]+ " " +blsuspicious[i][4]+ "\n"); }
            	}
            	else { cout.close(); break; }
        	}
        	return;
        
		} catch (IOException e) {
			System.out.println("IOException in write: " + e);
	    }
	}
/*	
	public static void addvhost(String nick, String vhost)
	{
		for (int i=0;i<vhlist.length;i++)
		{
			if (vhlist[i][0] != null && vhlist[i][0].equalsIgnoreCase(nick) && vhlist[i][1].equalsIgnoreCase(vhost)) { break; }
			else if (vhlist[i][0] != null && vhlist[i][0].equalsIgnoreCase(nick)) { vhlist[i][1] = vhost; break; }
			else if (vhlist[i][0] == null) { vhlist[i][0] = nick; vhlist[i][1] = vhost; break; }
		}
	}
*/	
	public static void unsetnewcheck()
	{
  		unsetnew = new Timer(wait, new ActionListener() {
    		public void actionPerformed(ActionEvent evt) {
    			checkvhost.newcheck = "";
    			unsetnew.stop();
      		}
  		});
  		unsetnew.start();
	}
}