import java.net.*;

public class dns extends Thread
{
	private String ip;
	private String target;
	
	public dns(String target, String ip)
	{
		this.ip = ip;
		this.target = target;
	}
	public void run()
	{
		String x = "";
		try {
			if (jbot.isItIP(ip)) {
				InetAddress a = InetAddress.getByName(ip);
				x = a.getCanonicalHostName();
			}
			else {
				InetAddress[] a = InetAddress.getAllByName(ip);
				for (int q = 0;q<a.length;q++)
				{
					if (q>0) { x += ", "; }
					x += a[q].getHostAddress();
				}
			}
			jbot.jmsg(target, "[DNS] Resolved "+ip+" -> "+x); return;
		}
		catch (Exception e) {
			jbot.jmsg(target, "[DNS] Unable to resolve "+ip); return;
		}
	}
}