import java.util.ArrayList;
import java.util.Hashtable;

public class glist extends Thread {
	private static ArrayList<String> list = new ArrayList<String>();
	private static ArrayList<String> nicks = new ArrayList<String>();
	private static Hashtable<String,String> hosts = new Hashtable<String,String>();
	private static boolean waiting=false,done=false;
	private static int repeats = 0;
	
	public glist() {
	}
	public static void addNick(String nick) {
		nicks.add(nick);
		//System.out.println("Adding nick "+nick+" to group for "+list.get(0));
	}
	public static void addCheck(String nick, String vhost) {
		if(!list.contains(nick))
			list.add(nick);
		hosts.put(nick,vhost);
		//System.out.println("Added nick to glist: "+nick+" "+vhost);
	}
	public void checkList() {
		if(!waiting && list.size()>0) {
			repeats = 0;
			if(done) {
				done=false;
				String[] allNicks = new String[nicks.size()];
				for(int i=0;i<nicks.size();i++)
					allNicks[i] = nicks.get(i);
				nicks.clear();
				String nick = list.remove(0);
				Thread vh = new checkvhost(nick,hosts.remove(nick),allNicks);
				//System.out.println("Starting checkvhost thread for: "+nick);
    			vh.start();
			}
			if(list.size()>0) {
				waiting = true;
				//System.out.println("Sending glist for: "+list.get(0));
				nicks.clear();
				jbot.sendln("ns glist "+list.get(0));
			}
		}
		else {
			if(list.size()>0) {
				repeats++;
				if(repeats == 120) {
					waiting = false;
					done = false;
				}
			}
		}
	}
	public static void setDone() {
		//System.out.println("Glist done for: "+list.get(0));
		done = true;
		waiting = false;
	}
	public static void clear() {
		list.clear();
		nicks.clear();
		hosts.clear();
		jbot.jmsg("hostserv", "waiting");
	}
	public void run() {
		while(true) {
			try {
				checkList();
			}
			catch(Exception e) { e.printStackTrace(); }
			try { Thread.sleep(500); }
			catch(Exception e) {}
		}
	}
}
