import java.net.*;
import java.io.*;

public class whois extends Thread
{
	private String target;
	private String host;
	
	public whois(String target, String host)
	{
		this.target = target;
		this.host = host;
	}
	
	public void run()
	{
		try
    	{
			Runtime runtime = Runtime.getRuntime();
			Process proc = runtime.exec("whois "+host);
			InputStream inputstream = proc.getInputStream();
			InputStreamReader inputstreamreader = new InputStreamReader(inputstream);
			BufferedReader bufferedreader = new BufferedReader(inputstreamreader);
			//OutputStream out = proc.putOutputStream();
			//shellout = new PrintWriter(proc.getOutputStream(), true);
    
			String line;
			while ((line = bufferedreader.readLine()) != null) {
				String[] sp = line.split("[ \\s]+");
				if (sp.length>0 && sp[0].length()>0) { jbot.jmsg(target, "[Whois] "+line); }
				//System.out.println(line);
			}
        
            // check for shell failure
			try {
				if (proc.waitFor() != 0) {
					System.err.println("exit value = " +proc.exitValue());
				}
			}
			catch (InterruptedException e) { System.err.println(e); }
			
			return;
		}
		catch (IOException e) {
			System.out.println("IOException: "+e);
			return;
		}
	}
}